#!/usr/bin/env python

import sys
import re
import string
import urllib
import sgmllib

senatoBaseURL = 'http://www.senato.it'
mailAddr = '<%s@posta.senato.it>'
senatoURL = senatoBaseURL + '/leg/16/BGT/Schede/Attsen/Sen%s.html'

class SenatoListParser(sgmllib.SGMLParser):
    def __init__(self, *args, **kwds):
        sgmllib.SGMLParser.__init__(self, *args, **kwds)

    def reset(self):
        sgmllib.SGMLParser.reset(self)
        self._in_composizione = False
        self._cur_link = None
        self._cur_name = ''
        self.linkList = []
        self.linkList = []

    def get_attr_value(self, attrs_list, searched_attr):
        for attr in attrs_list:
            if attr[0] == searched_attr:
                return attr[1]
        return None

    def start_ul(self, attrs):
        cls = self.get_attr_value(attrs, 'class')
        if cls and cls == 'composizione':
            self._in_composizione = True

    def end_ul(self):
        self._in_composizione = False

    def start_a(self, attrs):
        if not self._in_composizione: return
        href = self.get_attr_value(attrs, 'href')
        if not href: return
        if not href.startswith('/loc/link.asp?tipodoc=sattsen'): return
        self._cur_link = href

    def end_a(self):
        if not self._in_composizione: return
        if self._cur_link and self._cur_name:
            self.linkList.append((self._cur_name, self._cur_link))
            self._cur_link = None
            self._cur_name = ''

    def handle_data(self, data):
        if not self._in_composizione: return
        if not self._cur_link: return
        self._cur_name += data


re_mailName = re.compile(" mcmd \+ '(.+?)' \+ msrv ", re.I)

class SenatoEMailParser(sgmllib.SGMLParser):
    def __init__(self, *args, **kwds):
        sgmllib.SGMLParser.__init__(self, *args, **kwds)

    def reset(self):
        sgmllib.SGMLParser.reset(self)
        self.email = u''

    def handle_comment(self, data):
        if 'document.write(' in data:
            mname = re_mailName.search(data)
            if mname is not None:
                self.email = mname.group(1)


listParser = SenatoListParser()
emailParser = SenatoEMailParser()


mailFD = open('mails.txt', 'w')
for letter in string.lowercase:
    url = senatoURL % letter
    print 'Fetching "%s"...' % url,
    sys.stdout.flush()
    linkList = urllib.urlopen(url)
    listHtml = linkList.read()
    linkList.close()
    listParser.reset()
    listParser.feed(listHtml)
    links = list(listParser.linkList)
    print 'OK (%d entries)!' % len(links)
    for name, link in links:
        pPage = urllib.urlopen(senatoBaseURL + link)
        pPageContent = pPage.read()
        pPageFD = open('%s.html' % name.replace(' ', '_'), 'w')
        pPageFD.write(pPageContent)
        pPageFD.close()
        emailParser.reset()
        emailParser.feed(pPageContent)
        mailFD.write('%s %s\n' % (name, mailAddr % emailParser.email))
mailFD.close()

